// Default blockland prefs, as usual.

// REGISTRATIONS
// ---------------------------------------------------
registerPref("Server Name", "Blockland","General","$Server::Name","string 150", "","Blockland Server", false, false, "serverNameChanged", false);
registerPref("Welcome Message", "Blockland","General","$Server::WelcomeMessage", "string 255", "","\c3Welcome to Blockland, %1.", false, false, "welcomeMessageChanged", false);
registerPref("Max Players", "Blockland","General", "$Pref::Server::MaxPlayers", "playerlist 1 99", "", 12, false, false, "playerCountChanged", false);
registerPref("Server Password","Blockland","Security","$Pref::Server::Password","string 30", "", "", false, false, "", true);
registerPref("Admin Password","Blockland","Security","$Pref::Server::AdminPassword","string 30", "", "", false, false, "", true);
registerPref("Super Admin Password","Blockland","Security","$Pref::Server::SuperAdminPassword","string 30", "", "", false, false, "", true);
registerPref("Auto Admin IDs","Blockland","Security","$Pref::Server::AutoAdminList","bl_idlist _ -1", "", "", false, false, "autoAdminsChanged", true);
registerPref("Auto Super Admin IDs","Blockland","Security","$Pref::Server::AutoSuperAdminList","bl_idlist _ -1", "", "", false, true, "autoAdminsChanged", true);
registerPref("Filter","Blockland","E-Tard Filter","$Pref::Server::EtardFilter","bool", "", false, false, false, "", false);
registerPref("Words","Blockland","E-Tard Filter","$Pref::Server::EtardList","wordlist , 50", "", "", false, false, "", false);
registerPref("Max Bricks per Second","Blockland","Gameplay","$Server::MaxBricksPerSecond","int 0 999", "", 10, false, false, "maxBricksPerSecondChanged");
registerPref("Falling Damage","Blockland","Gameplay","$Pref::Server::FallingDamage","bool", "", true);
registerPref("Too Far Distance","Blockland","Gameplay","$Pref::Server::TooFarDistance","num 0 9999", "", 500);
registerPref("Admin Only Wrench Events","Blockland","Gameplay","$Server::WrenchEventsAdminOnly","bool", "", false, false, "wrenchEventsAdminOnlyChanged");
registerPref("Brick Ownership Decay","Blockland","Gameplay","$Pref::Server::BrickPublicDomainTimeout","int -1 99999", "", -1);

setPrefCategoryIcon("Blockland", "add-ons/Server_Prefs/resources/rtbicons/blLogo.png");

// CALLBACKS
// ---------------------------------------------------
function serverNameChanged() {
	$Pref::Server::Name = $Server::Name;
	
	playerCountChanged();
}

function welcomeMessageChanged() {
	$Pref::Server::WelcomeMessage = $Server::WelcomeMessage;
}

function maxBricksPerSecondChanged() {
	$Pref::Server::MaxBricksPerSecond = $Server::MaxBricksPerSecond;
}

function wrenchEventsAdminOnlyChanged() {
	$Pref::Server::WrenchEventsAdminOnly = $Server::WrenchEventsAdminOnly;
}

function playerCountChanged() {
	for(%i=0;%i<ClientGroup.getCount();%i++)
	{
		%cl = ClientGroup.getObject(%i);
		%cl.sendPlayerListUpdate();
	}
}

function autoAdminsChanged() {
	// update each player's admin status
	for(%i=0;%i<ClientGroup.getCount();%i++)
	{
		%cl = ClientGroup.getObject(%i);
		
		%status = %cl.checkAdminStatus();

		if(%status $= 2)
		{
		   if(%cl.isSuperAdmin)
			  continue;
		   
		   %cl.isAdmin = 1;
		   %cl.isSuperAdmin = 1;
		   %cl.sendPlayerListUpdate();
		   commandtoclient(%cl,'setAdminLevel',2);
		   messageAll('MsgAdminForce','\c2%1 has become Super Admin (Auto)',%cl.name);
		
		   RTBSC_SendPrefList(%client);
		}
		else if(%status == 1)
		{
		   if(%cl.isAdmin)
			  continue;
		   
		   %cl.isAdmin = 1;
		   %cl.isSuperAdmin = 0;
		   %cl.sendPlayerListUpdate();
		   commandtoclient(%cl,'setAdminLevel',1);
		   messageAll('MsgAdminForce','\c2%1 has become Admin (Auto)',%cl.name);
		}
		else if(%status == 0)
		{
		   if(!%cl.isAdmin)
			  continue;
		   
		   %cl.isAdmin = 0;
		   %cl.isSuperAdmin = 0;
		   %cl.sendPlayerListUpdate();
		   commandtoclient(%cl,'setAdminLevel',0);
		   messageAll('MsgAdminForce','\c2%1 is no longer Admin.',%cl.name);
		}
	}
}