// LOAD SCRIPTS M8
// --------------------------------------
exec("./prefs.cs");
exec("./commands.cs");
exec("./blockland.cs");

// PACKAGE
// --------------------------------------
if(isPackage(prefsServer))
	deactivatePackage(prefsServer);

// Override RTB_registerPref for legacy support
package prefsServer {
	function RTB_registerPref(%name, %category, %variable, %type, %folder, %default, %restartRequired, %hostOnly, %callback) {
		registerPref(%name, %category, "", %variable, %type, %folder, %default, %restartRequired, %hostOnly, %callback);
		Parent::RTB_registerPref(%name, %category, %variable, %type, %folder, %default, %restartRequired, %hostOnly, %callback);
	}

	function oRBs_registerPref(%name, %addon, %variable, %params, %file, %default, %requiresRestart, %hostOnly, %callback) {
		RTB_registerPref(%name, %addon, %variable, %params, %file, %default, %requiresRestart, %hostOnly, %callback);

		if(isFunction("oRBs_registerPref"))
			parent::oRBs_registerPref(%name, %addon, %variable, %params, %file, %default, %requiresRestart, %hostOnly, %callback);
	}
	
	function GameConnection::autoAdminCheck(%client)
	{
		commandToClient(%client, 'PrefsConnect');
		
		// new! Record every BL_ID that has joined ever...
		// This feature was requested by Zeblote.
		if($Pref::Server::Prefs::bl_idRecords $= "") {
			$Pref::Server::Prefs::bl_idRecords = 0;
		}
		
		%record = -1;
		
		// is this person's BL_ID already recorded?
		for(%i = 0; %i < $Pref::Server::Prefs::bl_idRecords; %i++) {
			%bl_id = getFirstWord($Pref::Server::Prefs::bl_idRecord[%i+1]);
			
			if(%client.bl_id == %bl_id) {
				// append to this record.
				%record = %i+1;
				break;
			}
		}
		
		if(%record == -1) {
			// append to new record
			%record = $Pref::Server::Prefs::bl_idRecords++;
		}
		
		$Pref::Server::Prefs::bl_idRecord[%record] = %client.bl_id SPC %client.name;
		
		return Parent::autoAdminCheck(%client);
	}
};

$Server::Prefs = true;
$RTB::Hooks::ServerControl = true; // RTB is totally on guys
$ORBS::Hooks::ServerControl = true; // yup oRBs too

activatePackage(prefsServer);